package chemShiftPredict;
/*
HASH Ha Chemical Shift Prediction  Software Version 1.0
Copyright (C) 2009-2012 Bruce Donald Lab, Duke University

HASH is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version.

HASH is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, see:
    <http://www.gnu.org/licenses/>.

There are additional restrictions imposed on the use and distribution of this
open-source code, including: (A) this header must be included in any
modification or extension of the code; (B) you are required to cite our
papers in any publications that use this code. The citation for the various
different modules of our software, together with a complete list of
requirements and restrictions are found in the document license.pdf enclosed
with this distribution.

Contact Info:
    Bruce R. Donald
    Duke University
    Department of Computer Science
    Levine Science Research Center (LSRC)
    Durham, NC 27708-0129
    USA
    email: www.cs.duke.edu/brd/

<signature of Bruce Donald>, 01 May, 2011
Bruce R. Donald, Professor of Computer Science and Biochemistry
*/

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

import rdcPanda.Assign;
import rdcPanda.H1CS;
import rdcPanda.Noe;
import rdcPanda.Pdb;

//compare the shift tables predicted by other software with the reference tables
public class compareTwoShiftTables {
	//compare with shifty
	public static void main1111 (String[] args){
		H1CS h1CS=new H1CS();
		Pdb pp=new Pdb();
		compareTwoShiftTables compTwoShiftTab=new compareTwoShiftTables();
		int counter=1;
		String userDir = System.getProperty("user.dir");
		String pathCSPred=userDir+"/system/cs_database/comparison/shifts_pred/";  //predicted chemical shift file directory	
	    String pathCSRef=userDir+"/system/cs_database/comparison/shifts_ref/";  //Reference chemical shift file directory
	    String pathPdb=userDir+"/system/cs_database/comparison/pdb/";  //Reference chemical shift file directory
	    
	    File myDir = new File(pathPdb);
    	String[] contents = myDir.list();//select all structures
    	if (contents == null) 
    		System.out.println(myDir.getName() + " is not a directory");
    	for (int t=0; t<contents.length;t++)  {  
    		String filename = contents[t]; 
			String fileNameSaved=filename.substring(0,filename.lastIndexOf("."));
    		
			String strPdbFile=pathPdb+filename;	
			Vector<Pdb> vecPdb=pp.readPdb(strPdbFile);
			
	    	String strRefCSFile="";
	    	filename=filename.substring(0,filename.lastIndexOf("."))+".txt";
	    	strRefCSFile=pathCSRef+filename;	    	
	    	Vector<H1CS> vecCSRef=h1CS.h1CSReader_BMRB(strRefCSFile);  
	    	
	    	filename=filename.substring(0,filename.lastIndexOf("."))+"_shifty.txt";
	    	String strCSPred=pathCSPred+filename;	    	
	    
	    	Vector<H1CS> vecCSPred=compTwoShiftTab.shiftReader_SHIFTY(strCSPred);  
	    	//Vector<H1CS> vecCSPred=compTwoShiftTab.shiftReader_SPARTA(strCSPred);  
	    	int[] invalidCounter=new int[1];
	    	//Vector<H1CS> vecCSPred=compTwoShiftTab.shiftReader_CAMSHIFT(strCSPred,invalidCounter); 
	    	
	    	for(int i=0;i<vecPdb.size();i++){
	    		double csHA_ref=-9999.9,csHA_pred=-9999.9;
	    		
	    		Pdb pdb=vecPdb.elementAt(i); 
	    		int No=pdb.getResidueNo();
	    		String curRes=pdb.getResidue();
	    		
	    		//find refence cs of HA
	    		for(int j=0;j<vecCSRef.size();j++){
		    		H1CS h1cs=(H1CS)vecCSRef.elementAt(j);
		    		int resNo=h1cs.getResidueNo();		    		
		    		String atom=h1cs.getAtomName();
		    		if(resNo==No && atom.equalsIgnoreCase("HA")){
		    			csHA_ref=h1cs.getH1CS();
		    			break;
		    		}	
		    	}//for(int i=0;i<vecCSTemp.size();i++)
	    		
	    		//find the cs of ha predicted by shifty
	    		for(int j=0;j<vecCSPred.size();j++){
	    			H1CS h1cs=(H1CS)vecCSPred.elementAt(j);
	    			int resNo=h1cs.getResidueNo();		    		
		    		String atom=h1cs.getAtomName();
		    		if(resNo==(i+1) && atom.equalsIgnoreCase("HA")){
		    			csHA_pred=h1cs.getH1CS();
		    			break;
		    		}	
	    		}//for(int j=0;j<vecCSPred.size();j++)
	    		
	    		//nmr outliers;
	    		/*if( (fileNameSaved.equalsIgnoreCase("4296") && no==63) || (fileNameSaved.equalsIgnoreCase("5275") && no==121) || (fileNameSaved.equalsIgnoreCase("2CYK") && no==53)||
	    				(fileNameSaved.equalsIgnoreCase("4425") && no==42) || (fileNameSaved.equalsIgnoreCase("4876") && no==34)||(fileNameSaved.equalsIgnoreCase("6120") && no==14) ||
	    				(fileNameSaved.equalsIgnoreCase("6799") && no==77) || (fileNameSaved.equalsIgnoreCase("5513") && no==66)||(fileNameSaved.equalsIgnoreCase("4876") && no==5)|| 
	    				(fileNameSaved.equalsIgnoreCase("6120") && no==24) || (fileNameSaved.equalsIgnoreCase("6364") && no==63))
	    			continue;*/
	    		
	    		//x-ray outlier:
	    		if(fileNameSaved.equalsIgnoreCase("5275") && No==103)
	    			continue;
	    		
	    		System.out.println(counter+ " "+No+" "+ (float)csHA_ref+" " +(float)csHA_pred+" "+ curRes+" "+fileNameSaved);
	    		counter++;
	    		
	    	}//for(int i=0;i<vecPdb.size();i++){
	    	
	    	
    	}//for (int t=0; t<contents.length;t++) 
	}
	
	
	
	//compare with sparta, shiftx and camshift.
	public static void main(String[] args){
		H1CS h1CS=new H1CS();
		compareTwoShiftTables compTwoShiftTab=new compareTwoShiftTables();
		int counter=1;
		String userDir = System.getProperty("user.dir");
		String pathCSPred=userDir+"/system/cs_database/comparison/shifts_pred/";  //predicted chemical shift file directory	
	    String pathCSRef=userDir+"/system/cs_database/comparison/shifts_ref/";  //Reference chemical shift file directory
	    
	    int totalResNum=0;
	    int missingNum=0;
	    Assign asg = new Assign();
	    
	    shiftx2Database shift2database=new shiftx2Database();
	    File myDir = new File(pathCSRef);
    	String[] contents = myDir.list();//select all structures
    	if (contents == null) 
    		System.out.println(myDir.getName() + " is not a directory");
    	
    	float sum=0.0f;
    	int numPredicted=0;
    	for (int t=0; t<contents.length;t++)  {  
    		String filename = contents[t]; 
			String fileNameSaved=filename.substring(0,filename.lastIndexOf("."));
    		
	    	String strRefCSFile="";
	    	strRefCSFile=pathCSRef+filename;	  
	    	
	    	String seqFile = userDir+"/inputFiles/ff2.seq";
	    	///Vector<Assign> vecSeq=asg.ReaderSeq(seqFile);    
	    	
	    	  Vector<H1CS> vecCSRef=h1CS.h1CSReader_BMRB(strRefCSFile);  
	    	////Vector<H1CS> vecCSRef=shift2database.h1CSReader_BMRB_Modified(strRefCSFile);  
	    	
	    	//Vector<H1CS> vecCSRef=h1CS.h1CSReader(strRefCSFile,vecSeq);  
	    	///Vector<H1CS> vecCSRef=h1CS.h1CSReader(strRefCSFile,vecSeq);  
	    	
	    	
	    	filename=filename.substring(0,filename.lastIndexOf("."))+"_pred.txt";
	    	String strCSPred=pathCSPred+filename;	    	
	    	
	    	int[] invalidCounter=new int[1];
///	 Vector<H1CS> vecCSPred=compTwoShiftTab.shiftReader_SHIFTX(strCSPred);  
 Vector<H1CS> vecCSPred=compTwoShiftTab.shiftReader_SPARTA(strCSPred);  
///	  Vector<H1CS> vecCSPred=compTwoShiftTab.shiftReader_SHIFTX2(strCSPred);
///	   	Vector<H1CS> vecCSPred=compTwoShiftTab.shiftReader_CAMSHIFT(strCSPred,invalidCounter); 
	    	
///   Vector<H1CS> vecCSPred=compTwoShiftTab.h1CSReader_SPARTAPlus(strCSPred); 
	    	//Vector<H1CS> vecCSPred=compTwoShiftTab.h1CSReader_PROSHIFT(strCSPred); 
	    	
	    	
	    	//find max res no and min res no	    		    	
	    	int minNoFromRefCS=9999999;
	    	int maxNoFromRefCS=-99999;
	    	for(int i=0;i<vecCSRef.size();i++){
	    		H1CS h1cs=(H1CS)vecCSRef.elementAt(i);
	    		int resNo=h1cs.getResidueNo();
	    		if(resNo>maxNoFromRefCS)
	    			maxNoFromRefCS=resNo;  
	    		if(resNo<minNoFromRefCS)
	    			minNoFromRefCS=resNo;
	    	}
	    	int minNoFromPredCS=9999999;
	    	int maxNoFromPredCS=-99999;
	    	for(int i=0;i<vecCSPred.size();i++){
	    		H1CS h1cs=(H1CS)vecCSPred.elementAt(i);
	    		int resNo=h1cs.getResidueNo();
	    		if(resNo>maxNoFromPredCS)
	    			maxNoFromPredCS=resNo;  
	    		if(resNo<minNoFromPredCS)
	    			minNoFromPredCS=resNo;
	    	}
	    	int maxNo=Math.min(maxNoFromRefCS, maxNoFromPredCS);
	    	int minNo=Math.max(minNoFromRefCS, minNoFromPredCS);
	    	
	    	
	    	for(int no=minNoFromRefCS;no<=maxNoFromRefCS;no++){	
	    		double csHA_ref=-9999.9,csHA_pred=-9999.9;
	    		String curRes="";
	    		
	    		//get residue name
	    		for(int i=0;i<vecCSRef.size();i++){
	    			H1CS h1cs=(H1CS)vecCSRef.elementAt(i);
		    		int resNo=h1cs.getResidueNo();
		    		if(resNo==no){
		    			curRes=h1cs.getResidueType();
		    			break;
		    		}	    			
	    		}
	    	
	    		//find refence cs of HA
	    		for(int i=0;i<vecCSRef.size();i++){
		    		H1CS h1cs=(H1CS)vecCSRef.elementAt(i);
		    		int resNo=h1cs.getResidueNo();		    		
		    		String atom=h1cs.getAtomName();
		    		if(resNo==no && atom.equalsIgnoreCase("HA")){
		    			csHA_ref=h1cs.getH1CS();
		    			break;
		    		}	
		    	}//for(int i=0;i<vecCSTemp.size();i++)
	    		
	    		//for GLY, we compute the mean of two HA chemical shifts
	    		if(curRes.equalsIgnoreCase("GLY") || curRes.equalsIgnoreCase("G")){
	    			double sumHaCS=0.0;	  
	    			int counterHaCS=0;
	    			boolean isFoundHaForGly=false;
	    			for(int i=0;i<vecCSRef.size();i++){
			    		H1CS h1cs=(H1CS)vecCSRef.elementAt(i);
			    		int resNo=h1cs.getResidueNo();		    		
			    		String atom=h1cs.getAtomName();
			    		if(atom.length()>=2)
			    			atom=atom.substring(0,2);
			    		if(resNo==no && atom.equalsIgnoreCase("HA")){
			    			sumHaCS=sumHaCS+h1cs.getH1CS();
			    			counterHaCS++;
			    			isFoundHaForGly=true;
			    		}	
			    	}//for(int i=0;i<vecCSTemp.size();i++)
	    			if(isFoundHaForGly){
	    				csHA_ref=sumHaCS/counterHaCS;
	    			}	    			
	    		}//if(curRes.equalsIgnoreCase("GLY") || curRes.equalsIgnoreCase("G"))
	    		
	    		//find predicted cs of HA
	    		for(int i=0;i<vecCSPred.size();i++){
		    		H1CS h1cs=(H1CS)vecCSPred.elementAt(i);
		    		int resNo=h1cs.getResidueNo();		    		
		    		String atom=h1cs.getAtomName();		    	
		    		if(resNo==no && atom.equalsIgnoreCase("HA")){
		    			csHA_pred=h1cs.getH1CS();
		    			break;
		    		}	
		    	}//for(int i=0;i<vecCSTemp.size();i++)
	    		
	    		//nmr outliers;
	    		/*if( (fileNameSaved.equalsIgnoreCase("4296") && no==63) || (fileNameSaved.equalsIgnoreCase("5275") && no==121) || (fileNameSaved.equalsIgnoreCase("2CYK") && no==53)||
	    				(fileNameSaved.equalsIgnoreCase("4425") && no==42) || (fileNameSaved.equalsIgnoreCase("4876") && no==34)||(fileNameSaved.equalsIgnoreCase("6120") && no==14) ||
	    				(fileNameSaved.equalsIgnoreCase("6799") && no==77) || (fileNameSaved.equalsIgnoreCase("5513") && no==66)||(fileNameSaved.equalsIgnoreCase("4876") && no==5)|| 
	    				(fileNameSaved.equalsIgnoreCase("6120") && no==24) || (fileNameSaved.equalsIgnoreCase("6364") && no==63))
	    			continue;*/
	    		
	    		//x-ray outlier:
	    		if(fileNameSaved.equalsIgnoreCase("5275") && no==103)
	    			continue;
	    		
	    		if(csHA_ref<-300.0 || csHA_ref>300.0)
	    			continue;
	    		
	    		if(csHA_pred<-300.0 || csHA_pred>300.0)
	    			continue;
	    		
	    		numPredicted++;
	    		sum=(float) (sum+(csHA_ref-csHA_pred)*(csHA_ref-csHA_pred));
	    		System.out.println(counter+ " "+no+" "+ (float)csHA_ref+" " +(float)csHA_pred+" "+ curRes+" "+fileNameSaved);
	    		counter++;
	    		
	    	}//for(int no=minNo;no<=maxNo;no++)
	    	
	    	totalResNum+=(maxNo-minNo+1);
	    	missingNum+=invalidCounter[0];
    	}//for (int t=0; t<contents.length;t++)
	    
    	float rmsd=(float)Math.sqrt(sum/numPredicted);
    	
    	System.out.println("# Total number of residues: "+ totalResNum);
    	System.out.println("# Total number of missing predicted chemical shifts: "+ missingNum);
    	System.out.println("# Percentage of missing predicted chemical shifts: "+ (float)missingNum/totalResNum);
    	
    	System.out.println("The rmsd is: "+rmsd);
    	
	}
	
	
	   /**
     * Another method for reading chemical shifts, in SHIFTX format.
     * 
     * @param filename the name of the file
     * 
     * @return a vector of h1cs object
     */
    public Vector<H1CS> shiftReader_SHIFTY(String filename)
    {    	 
    	H1CS h1cs=new H1CS();
     	Vector inputs = new Vector();
     //	double csHN = 0.0, csN15 = 0.0, csH1 = 0.0, intensity = 0.0;
     	//Vector csVec = new Vector();
     	StringTokenizer st = new StringTokenizer("");
     	String str = "";
     	int index1=0, index2=0;
     	String order="";
     	double value=0.0;
     	int no =0;
     	String aaType = "", ss ="";
     	String atomName="";
     	String resName="";
     	int resNo=0;
     	double csCa=0.0,csHa=0.0,csN=0.0,csHN=0.0, csCO=0.0,csCB=0.0;
     	int csID=0;
     	//Noe noe=new Noe();
     	
     	try
     	{
     		BufferedReader in = new BufferedReader(new FileReader(filename));	
     		ss = in.readLine();
     		
     		stop:
     			while(true) 
     			{   		
     				csHN=-9999.9;
     				csHa=-9999.9;
     				st = new StringTokenizer(ss);
     				     
     				String strFirst="";
     				if (st.hasMoreTokens()){
     					strFirst=st.nextToken();
     					strFirst=strFirst.trim();
     					String strTemp=strFirst.substring(0,1);
     					if(h1cs.isIntNumber(strFirst) ){    						
    						resNo= Integer.parseInt(strFirst);   					
    					}//if(isIntNumber(strFirst) )     					
     					else
     					{
     						if ((ss = in.readLine()) == null )
 	        				{
 	        					break stop;
 	        				}
     						continue;
     					}
     				} 
     				else
 					{
 						if ((ss = in.readLine()) == null )
	        				{
	        					break stop;
	        				}
 						continue;
 					}
     				 
     				if (st.hasMoreTokens())
     					resName = st.nextToken();
     				
     				if (st.hasMoreTokens()){
     					strFirst = st.nextToken();
     					strFirst=strFirst.trim();
     					String strTemp=strFirst.substring(0,1);
     					if(!strTemp.equalsIgnoreCase("=")){    					
     						if ((ss = in.readLine()) == null )
 	        				{
 	        					break stop;
 	        				}
     						continue;
     					}
     				}
     				
     				if (st.hasMoreTokens())
     					strFirst = st.nextToken();
     				
     				if (st.hasMoreTokens())
     					strFirst = st.nextToken();
     				
     				if (st.hasMoreTokens()){
     					strFirst = st.nextToken();
     					strFirst=strFirst.trim();
     					String strTemp=strFirst.substring(0,1);
     					if(h1cs.isIntNumber(strTemp) ){
     						//System.out.println();
     						csHN  = new Double(strFirst).doubleValue();   
     					}
     				}
     					
     				if (st.hasMoreTokens()){
     					strFirst = st.nextToken();
     					strFirst=strFirst.trim();
     					String strTemp=strFirst.substring(0,1);
     					if(h1cs.isIntNumber(strTemp) )
     						csHa  = new Double(strFirst).doubleValue();  
     				}
     				
     				     				
     				//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
     				inputs.add(new H1CS(resNo, resName, "HA", csHa));
     				//add others....
     				
     				
     				if ((ss = in.readLine()) == null){
     					break stop;
     				}
     				else if(ss.equalsIgnoreCase(""))
     				{
     					if ((ss = in.readLine()) == null )
         				{
         					break stop;
         				}
     				}
     			}
     	}catch (FileNotFoundException e) {
     		System.out.println("File not found: " + filename);
     	}catch (IOException e) 
     	{
     		System.out.println("IOException: the stack trace is:");
     		e.printStackTrace();
     	}
     	return inputs;
     }
    
	
	   /**
  * Another method for reading chemical shifts, in CAMSHIFT format.
  * 
  * @param filename the name of the file
  * 
  * @return a vector of h1cs object
  */
 public Vector<H1CS> shiftReader_CAMSHIFT(String filename, int[] number)
 {    	 
	int invalidCounter=0;
 	H1CS h1cs=new H1CS();
  	Vector inputs = new Vector();
 
  	StringTokenizer st = new StringTokenizer("");  
  	String  ss ="";
  	
  	String resName="";
  	int resNo=0;
  	double csCa=0.0,csHa=0.0,csN=0.0,csHN=0.0, csCO=0.0,csCB=0.0;
  	int csID=0;
  	//Noe noe=new Noe();
  	String strFirst="";
  	String strTemp="";
  	try
  	{
  		BufferedReader in = new BufferedReader(new FileReader(filename));	
  		ss = in.readLine();
  		
  		stop:
  			while(true) 
  			{   			    
  				st = new StringTokenizer(ss);
  				csCa=-9999.9;
  				csHa=-9999.9;
  				csN=-9999.9;
  				csHN=-9999.9;
  				csCO=-9999.9;
  				csCB=-9999.9;
  				
  				if (st.hasMoreTokens()){
  					strTemp=st.nextToken();
  					strTemp=strTemp.trim();
  					strFirst=strTemp.substring(0,1);
  					if(h1cs.isIntNumber(strFirst)){
  						csHa= new Double(strTemp).doubleValue();
  					}
  					else{
  						invalidCounter++;
  						if ((ss = in.readLine()) == null )
        				{
        					break stop;
        				}
						continue;
  					}
  				}//if (st.hasMoreTokens())
  				 
  				if (st.hasMoreTokens()){
  					strTemp=st.nextToken();
  					strTemp=strTemp.trim();
  					strFirst=strTemp.substring(0,1);
  					if(h1cs.isIntNumber(strFirst))
  						csCa= new Double(strTemp).doubleValue();  
  					else
 					{
 						
 					}
  				}//if (st.hasMoreTokens())
  				
  				if (st.hasMoreTokens()){
  					strTemp=st.nextToken();
  					strTemp=strTemp.trim();
  					strFirst=strTemp.substring(0,1);
  					if(h1cs.isIntNumber(strFirst))
  						csHN= new Double(strTemp).doubleValue();  
  					else
 					{
 						
 					}
  				}//if (st.hasMoreTokens())
  				if (st.hasMoreTokens()){
  					strTemp=st.nextToken();
  					strTemp=strTemp.trim();
  					strFirst=strTemp.substring(0,1);
  					if(h1cs.isIntNumber(strFirst))
  						csN= new Double(strTemp).doubleValue();  	
  					else
 					{
 						
 					}
  				}//if (st.hasMoreTokens())
  				if (st.hasMoreTokens()){
  					strTemp=st.nextToken();
  					strTemp=strTemp.trim();
  					strFirst=strTemp.substring(0,1);
  					if(h1cs.isIntNumber(strFirst))
  						csCO= new Double(strTemp).doubleValue();  
  					else
 					{
 						
 					}
  				}//if (st.hasMoreTokens())
  				if (st.hasMoreTokens()){
  					strTemp=st.nextToken();
  					strTemp=strTemp.trim();
  					strFirst=strTemp.substring(0,1);
  					if(h1cs.isIntNumber(strFirst))
  						csCB= new Double(strTemp).doubleValue();  	
  					else
 					{
 						
 					}
  				}//if (st.hasMoreTokens())
  				
  				
  				if (st.hasMoreTokens())
  					strTemp = st.nextToken();
  				
  				if (st.hasMoreTokens())
  					strTemp = st.nextToken();
  				if (st.hasMoreTokens())
  					strTemp = st.nextToken();
  				if (st.hasMoreTokens())
  					strTemp = st.nextToken();
  				
  				if (st.hasMoreTokens()){
  					strTemp = st.nextToken();
  					strTemp=strTemp.substring(0,strTemp.lastIndexOf(")"));
  					resNo= Integer.parseInt(strTemp);  
  				}
  				
  				//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
  				inputs.add(new H1CS(resNo, "", "HA", csHa));
  				//add others....
  				
  				
  				if ((ss = in.readLine()) == null){
  					break stop;
  				}
  				else if(ss.equalsIgnoreCase(""))
  				{
  					if ((ss = in.readLine()) == null )
      				{
      					break stop;
      				}
  				}
  			}
  	}catch (FileNotFoundException e) {
  		System.out.println("File not found: " + filename);
  	}catch (IOException e) 
  	{
  		System.out.println("IOException: the stack trace is:");
  		e.printStackTrace();
  	}
  	number[0]=invalidCounter;
  	return inputs;
  }
 
 /**
* Another method for reading chemical shifts, in CAMSHIFT format.
* 
* @param filename the name of the file
* 
* @return a vector of h1cs object
*/
public Vector<H1CS> shiftReader_CAMSHIFT_ReadAll(String filename, int[] number)
{    	 
int invalidCounter=0;
H1CS h1cs=new H1CS();
Vector inputs = new Vector();

StringTokenizer st = new StringTokenizer("");  
String  ss ="";

String resName="";
int resNo=0;
double csCa=0.0,csHa=0.0,csN=0.0,csHN=0.0, csCO=0.0,csCB=0.0;
int csID=0;
//Noe noe=new Noe();
String strFirst="";
String strTemp="";
try
{
	BufferedReader in = new BufferedReader(new FileReader(filename));	
	ss = in.readLine();
	
	stop:
		while(true) 
		{   			    
			st = new StringTokenizer(ss);
			csCa=-9999.9;
			csHa=-9999.9;
			csN=-9999.9;
			csHN=-9999.9;
			csCO=-9999.9;
			csCB=-9999.9;
			
			if (st.hasMoreTokens()){
				strTemp=st.nextToken();
				strTemp=strTemp.trim();
				strFirst=strTemp.substring(0,1);
				if(h1cs.isIntNumber(strFirst)){
					csHa= new Double(strTemp).doubleValue();
				}
				else{
					invalidCounter++;
					if ((ss = in.readLine()) == null )
  				{
  					break stop;
  				}
					continue;
				}
			}//if (st.hasMoreTokens())
			 
			if (st.hasMoreTokens()){
				strTemp=st.nextToken();
				strTemp=strTemp.trim();
				strFirst=strTemp.substring(0,1);
				if(h1cs.isIntNumber(strFirst))
					csCa= new Double(strTemp).doubleValue();  
				else
				{
					if ((ss = in.readLine()) == null )
      				{
      					break stop;
      				}
					continue;
				}
			}//if (st.hasMoreTokens())
			
			if (st.hasMoreTokens()){
				strTemp=st.nextToken();
				strTemp=strTemp.trim();
				strFirst=strTemp.substring(0,1);
				if(h1cs.isIntNumber(strFirst))
					csHN= new Double(strTemp).doubleValue();  
				else
				{
					if ((ss = in.readLine()) == null )
      				{
      					break stop;
      				}
					continue;
				}
			}//if (st.hasMoreTokens())
			if (st.hasMoreTokens()){
				strTemp=st.nextToken();
				strTemp=strTemp.trim();
				strFirst=strTemp.substring(0,1);
				if(h1cs.isIntNumber(strFirst))
					csN= new Double(strTemp).doubleValue();  	
				else
				{
					if ((ss = in.readLine()) == null )
      				{
      					break stop;
      				}
					continue;
				}
			}//if (st.hasMoreTokens())
			if (st.hasMoreTokens()){
				strTemp=st.nextToken();
				strTemp=strTemp.trim();
				strFirst=strTemp.substring(0,1);
				if(h1cs.isIntNumber(strFirst))
					csCO= new Double(strTemp).doubleValue();  
				else
				{
					if ((ss = in.readLine()) == null )
      				{
      					break stop;
      				}
					continue;
				}
			}//if (st.hasMoreTokens())
			if (st.hasMoreTokens()){
				strTemp=st.nextToken();
				strTemp=strTemp.trim();
				strFirst=strTemp.substring(0,1);
				if(h1cs.isIntNumber(strFirst))
					csCB= new Double(strTemp).doubleValue();  	
				else
				{
					if ((ss = in.readLine()) == null )
      				{
      					break stop;
      				}
					continue;
				}
			}//if (st.hasMoreTokens())
			
			
			if (st.hasMoreTokens())
				strTemp = st.nextToken();
			
			if (st.hasMoreTokens())
				strTemp = st.nextToken();
			if (st.hasMoreTokens())
				strTemp = st.nextToken();
			if (st.hasMoreTokens())
				strTemp = st.nextToken();
			
			if (st.hasMoreTokens()){
				strTemp = st.nextToken();
				strTemp=strTemp.substring(0,strTemp.lastIndexOf(")"));
				resNo= Integer.parseInt(strTemp);  
			}
			
			//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
			inputs.add(new H1CS(resNo, "", "HA", csHa));
			//add others....
			
			
			if ((ss = in.readLine()) == null){
				break stop;
			}
			else if(ss.equalsIgnoreCase(""))
			{
				if ((ss = in.readLine()) == null )
				{
					break stop;
				}
			}
		}
}catch (FileNotFoundException e) {
	System.out.println("File not found: " + filename);
}catch (IOException e) 
{
	System.out.println("IOException: the stack trace is:");
	e.printStackTrace();
}
number[0]=invalidCounter;
return inputs;
}
	
	   /**
     * Another method for reading chemical shifts, in SHIFTX format.
     * 
     * @param filename the name of the file
     * 
     * @return a vector of h1cs object
     */
    public Vector<H1CS> shiftReader_SHIFTX(String filename)
    {    	 
    	H1CS h1cs=new H1CS();
     	Vector inputs = new Vector();
     //	double csHN = 0.0, csN15 = 0.0, csH1 = 0.0, intensity = 0.0;
     	//Vector csVec = new Vector();
     	StringTokenizer st = new StringTokenizer("");
     	String str = "";
     	int index1=0, index2=0;
     	String order="";
     	double value=0.0;
     	int no =0;
     	String aaType = "", ss ="";
     	String atomName="";
     	String resName="";
     	int resNo=0;
     	double csCa=0.0,csHa=0.0,csN=0.0,csHN=0.0, csCO=0.0,csCB=0.0;
     	int csID=0;
     	//Noe noe=new Noe();
     	
     	try
     	{
     		BufferedReader in = new BufferedReader(new FileReader(filename));	
     		ss = in.readLine();
     		
     		stop:
     			while(true) 
     			{   			    
     				st = new StringTokenizer(ss);
     				     
     				String strFirst="";
     				if (st.hasMoreTokens()){
     					strFirst=st.nextToken();
     					strFirst=strFirst.trim();
     					String strTemp=strFirst.substring(0,1);
     					if(h1cs.isIntNumber(strFirst) ){    						
    						resNo= Integer.parseInt(strFirst);   					
    					}//if(isIntNumber(strFirst) )
     					else if(strTemp.equalsIgnoreCase("*")){
     						strFirst=strFirst.substring(1,strFirst.length());
     						resNo= Integer.parseInt(strFirst);  
     					}
     					else
     					{
     						if ((ss = in.readLine()) == null )
 	        				{
 	        					break stop;
 	        				}
     						continue;
     					}
     				}     				
     				 
     				if (st.hasMoreTokens())
     					resName = st.nextToken();
     				
     				if (st.hasMoreTokens())
     					csHa  = new Double(st.nextToken()).doubleValue();
     				
     				if (st.hasMoreTokens())
     					csHN  = new Double(st.nextToken()).doubleValue();
     				if (st.hasMoreTokens())
     					csN  = new Double(st.nextToken()).doubleValue();
     				if (st.hasMoreTokens())
     					csCa  = new Double(st.nextToken()).doubleValue();
     				if (st.hasMoreTokens())
     					csCB  = new Double(st.nextToken()).doubleValue();
     				if (st.hasMoreTokens())
     					csCO  = new Double(st.nextToken()).doubleValue();  				
     				     				
     				
     				//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
     				inputs.add(new H1CS(resNo, resName, "HA", csHa));
     				//add others....
     				
     				
     				if ((ss = in.readLine()) == null){
     					break stop;
     				}
     				else if(ss.equalsIgnoreCase(""))
     				{
     					if ((ss = in.readLine()) == null )
         				{
         					break stop;
         				}
     				}
     			}
     	}catch (FileNotFoundException e) {
     		System.out.println("File not found: " + filename);
     	}catch (IOException e) 
     	{
     		System.out.println("IOException: the stack trace is:");
     		e.printStackTrace();
     	}
     	return inputs;
     }
    
	   /**
  * Another method for reading chemical shifts, in SHIFTX format.
  * format: Num  RES       CA       CB       CO        N        H       HA
  * @param filename the name of the file
  * 
  * @return a vector of h1cs object
  */
    public Vector<H1CS> shiftReader_SHIFTX2(String filename)
    {    	 
	 	H1CS h1cs=new H1CS();
	  	Vector inputs = new Vector();
	    //double csHN = 0.0, csN15 = 0.0, csH1 = 0.0, intensity = 0.0;
	  	//Vector csVec = new Vector();
	  	StringTokenizer st = new StringTokenizer("");
	  	String str = "";
	  	int index1=0, index2=0;
	  	String order="";
	  	double value=0.0;
	  	int no =0;
	  	String aaType = "", ss ="";
	  	String atomName="";
	  	String resName="";
	  	int resNo=0;
	  	double csCa=0.0,csHa=0.0,csN=0.0,csHN=0.0, csCO=0.0,csCB=0.0;
	  	int csID=0;
	  	//Noe noe=new Noe();
  	
	  	refDB refdb=new refDB();
	  	
	  	try
	  	{
	  		BufferedReader in = new BufferedReader(new FileReader(filename));	
	  		ss = in.readLine();
	  		
	  		stop:
	  			while(true) 
	  			{   			    
	  				st = new StringTokenizer(ss);
	  				     
	  				String strFirst="";
	  				if (st.hasMoreTokens()){
	  					strFirst=st.nextToken();
	  					strFirst=strFirst.trim();
	  					String strTemp=strFirst.substring(0,1);
	  					if(h1cs.isIntNumber(strFirst) ){    						
	 						resNo= Integer.parseInt(strFirst);   					
	 					}//if(isIntNumber(strFirst) )
	  					else if(strTemp.equalsIgnoreCase("*")){
	  						strFirst=strFirst.substring(1,strFirst.length());
	  						resNo= Integer.parseInt(strFirst);  
	  					}
	  					else
	  					{
	  						if ((ss = in.readLine()) == null )
		        				{
		        					break stop;
		        				}
	  						continue;
	  					}
	  				}     				
	  				 
	  				if (st.hasMoreTokens())
	  					resName = st.nextToken();
	  				
	  				if (st.hasMoreTokens()){
	  					String strTemp = st.nextToken().trim();
	  					if(refDB.isNumeric(strTemp))
	  						csCa  = new Double(strTemp).doubleValue();
	  				}
	  					
	  				if (st.hasMoreTokens()){
	  					String strTemp = st.nextToken();
	  					if(refDB.isNumeric(strTemp))
	  						csCB  = new Double(strTemp).doubleValue();
	  				}
	  					
	  				if (st.hasMoreTokens()){
	  					String strTemp = st.nextToken();
	  					if(refDB.isNumeric(strTemp))
	  						csCO  = new Double(strTemp).doubleValue(); 
	  				}
	  					
	  						 		
	  				if (st.hasMoreTokens()){
	  					String strTemp = st.nextToken();
	  					if(refDB.isNumeric(strTemp))
	  						csN  = new Double(strTemp).doubleValue();
	  				}
	  					
	  						
	  				if (st.hasMoreTokens())
	  				{
	  					String strTemp = st.nextToken();
	  					if(refDB.isNumeric(strTemp))
	  						csHN  = new Double(strTemp).doubleValue();
	  				}
	  					  				
	  						
	  				if (st.hasMoreTokens()){
	  					String strTemp = st.nextToken();
	  					if(refDB.isNumeric(strTemp))
	  						csHa  = new Double(strTemp).doubleValue();	
	  				}
	  						  									
	  				
	  				//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
	  				inputs.add(new H1CS(resNo, resName, "HA", csHa));
	  				//add others....
	  				
	  				
	  				if ((ss = in.readLine()) == null){
	  					break stop;
	  				}
	  				else if(ss.equalsIgnoreCase(""))
	  				{
	  					if ((ss = in.readLine()) == null )
	      				{
	      					break stop;
	      				}
	  				}
	  			}
	  	}catch (FileNotFoundException e) {
	  		System.out.println("File not found: " + filename);
	  	}catch (IOException e) 
	  	{
	  		System.out.println("IOException: the stack trace is:");
	  		e.printStackTrace();
	  	}
	  	return inputs;
  }
 
	   /**
     * Another method for reading chemical shifts, in SPARTA format.
     * 
     * @param filename the name of the file
     * 
     * @return a vector of h1cs object
     */
    public Vector<H1CS> shiftReader_SPARTA(String filename)
    {    	 
    	H1CS h1cs=new H1CS();
     	Vector inputs = new Vector();
     //	double csHN = 0.0, csN15 = 0.0, csH1 = 0.0, intensity = 0.0;
     	//Vector csVec = new Vector();
     	StringTokenizer st = new StringTokenizer("");
     	String str = "";
     	int index1=0, index2=0;
     	String order="";
     	double value=0.0;
     	int no =0;
     	String aaType = "", ss ="";
     	String atomName="";
     	String resName="";
     	int resNo=0;
     	double csCa=0.0,csHa=0.0,csN=0.0,csHN=0.0, csCO=0.0,csCB=0.0;
     	int csID=0;
     	//Noe noe=new Noe();
     	
     	try
     	{
     		BufferedReader in = new BufferedReader(new FileReader(filename));	
     		ss = in.readLine();
     		
     		stop:
     			while(true) 
     			{   			    
     				st = new StringTokenizer(ss);
     				     
     				String strFirst="";
     				if (st.hasMoreTokens()){
     					strFirst=st.nextToken();
     					strFirst=strFirst.trim();
     					String strTemp=strFirst.substring(0,1);
     					if(!strTemp.equalsIgnoreCase("#") ){    						
     						csN=  new Double(strFirst).doubleValue();					
    					}//if(isIntNumber(strFirst) )
     					else
     					{
     						if ((ss = in.readLine()) == null )
 	        				{
 	        					break stop;
 	        				}
     						continue;
     					}
     				}     				
     				    				
     				if (st.hasMoreTokens())
     					csHa  = new Double(st.nextToken()).doubleValue();
     				
     				if (st.hasMoreTokens())
     					csCO  = new Double(st.nextToken()).doubleValue();
     				if (st.hasMoreTokens())
     					csCa  = new Double(st.nextToken()).doubleValue();     				
     				if (st.hasMoreTokens())
     					csCB  = new Double(st.nextToken()).doubleValue();
     				if (st.hasMoreTokens())
     					csHN  = new Double(st.nextToken()).doubleValue();
     				if (st.hasMoreTokens())
     					resNo= Integer.parseInt(st.nextToken());   	
     				if (st.hasMoreTokens())
     					resName = st.nextToken();
     				
     				
     				//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
     				inputs.add(new H1CS(resNo, resName, "HA", csHa));
     				//add others....
     				
     				
     				if ((ss = in.readLine()) == null){
     					break stop;
     				}
     				else if(ss.equalsIgnoreCase(""))
     				{
     					if ((ss = in.readLine()) == null )
         				{
         					break stop;
         				}
     				}
     			}
     	}catch (FileNotFoundException e) {
     		System.out.println("File not found: " + filename);
     	}catch (IOException e) 
     	{
     		System.out.println("IOException: the stack trace is:");
     		e.printStackTrace();
     	}
     	return inputs;
     }
    
    
    /**
     * Another method for reading chemical shifts, in sparta+ format.
     * 
     * @param filename the name of the file
     * 
     * @return a vector of h1cs object
     */
     public Vector<H1CS> h1CSReader_SPARTAPlus(String filename)
     {
     	Vector inputs = new Vector();
     	double csHN = 0.0, csN15 = 0.0, csH1 = 0.0, intensity = 0.0;
     	Vector csVec = new Vector();
     	StringTokenizer st = new StringTokenizer("");
     	String str = "";
     	int index1=0, index2=0;
     	String order="";
     	double value=0.0;
     	int no =0;
     	String aaType = "", ss ="";
     	String atomName="";
     	String resName="";
     	int resNo=0;
     	int csID=0;
     	Noe noe=new Noe();
     	
     	try
     	{
     		BufferedReader in = new BufferedReader(new FileReader(filename));	
     		ss = in.readLine();
     		ss=ss.trim();
     		
     		stop:
     			while(true) 
     			{   	
     				if(ss.equalsIgnoreCase(""))
      				{
      					if ((ss = in.readLine()) == null )
          				{
          					break stop;
          				}
      					continue;
      				}
     				 
     				st = new StringTokenizer(ss);
     				     					
     				if (st.hasMoreTokens())
     					resNo =  Integer.parseInt(st.nextToken());
     				
     				if (st.hasMoreTokens())
     					resName = st.nextToken();
     				
     				if (st.hasMoreTokens())
     					atomName = st.nextToken();
     				
     				if (st.hasMoreTokens())
     					aaType = st.nextToken();
     				
     				if (st.hasMoreTokens())
     					csH1  = new Double(st.nextToken()).doubleValue();
     				
     				if (csH1>300.0 || csH1<-300.0)
 					{
 						if ((ss = in.readLine()) == null)
 							break stop;     
 						else if(ss.equalsIgnoreCase(""))
 	    				{
 	    					if ((ss = in.readLine()) == null )
 	        				{
 	        					break stop;
 	        				}
 	    				}
 						continue;
 					}
     				
     				//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
     				inputs.add(new H1CS(resNo, resName, atomName, csH1));
     				if ((ss = in.readLine()) == null){
     					break stop;
     				}
     				else if(ss.equalsIgnoreCase(""))
     				{
     					if ((ss = in.readLine()) == null )
         				{
         					break stop;
         				}
     				}
     			}
     	}catch (FileNotFoundException e) {
     		System.out.println("File not found: " + filename);
     	}catch (IOException e) 
     	{
     		System.out.println("IOException: the stack trace is:");
     		e.printStackTrace();
     	}
     	return inputs;
     }
   
     
     /**
      * Another method for reading chemical shifts, in sparta+ format.
      * 
      * @param filename the name of the file
      * 
      * @return a vector of h1cs object
      */
      public Vector<H1CS> h1CSReader_PROSHIFT(String filename)
      {
      	Vector inputs = new Vector();
      	double csHN = 0.0, csN15 = 0.0, csH1 = 0.0, intensity = 0.0;
      	Vector csVec = new Vector();
      	StringTokenizer st = new StringTokenizer("");
      	String str = "";
      	int index1=0, index2=0;
      	String order="";
      	double value=0.0;
      	int no =0;
      	String aaType = "", ss ="";
      	String atomName="";
      	String resName="";
      	int resNo=0;
      	int csID=0;
      	Noe noe=new Noe();
      	
      	try
      	{
      		BufferedReader in = new BufferedReader(new FileReader(filename));	
      		ss = in.readLine();
      		ss=ss.trim();
      		
      		stop:
      			while(true) 
      			{   	
      				if(ss.equalsIgnoreCase(""))
       				{
       					if ((ss = in.readLine()) == null )
           				{
           					break stop;
           				}
       					continue;
       				}
      				 
      				st = new StringTokenizer(ss);
      				     					
      				if (st.hasMoreTokens())
      				   str=st.nextToken();
      				if (st.hasMoreTokens())
      					csID =  Integer.parseInt(st.nextToken());
      				if (st.hasMoreTokens())
      					atomName = st.nextToken();
      				if (st.hasMoreTokens())
      					resName = st.nextToken();
      				
      				if (st.hasMoreTokens())
       				   str=st.nextToken();
      				
      				if (st.hasMoreTokens())
      					resNo =  Integer.parseInt(st.nextToken());    				
      				
      				
      				if (st.hasMoreTokens())
      					csH1  = new Double(st.nextToken()).doubleValue();
      				
      				if (csH1>300.0 || csH1<-300.0)
  					{
  						if ((ss = in.readLine()) == null)
  							break stop;     
  						else if(ss.equalsIgnoreCase(""))
  	    				{
  	    					if ((ss = in.readLine()) == null )
  	        				{
  	        					break stop;
  	        				}
  	    				}
  						continue;
  					}
      				
      				//atomName=noe.UpdateNOEAtomName2(resName, atomName);//changed here
      				inputs.add(new H1CS(resNo, resName, atomName, csH1));
      				if ((ss = in.readLine()) == null){
      					break stop;
      				}
      				else if(ss.equalsIgnoreCase(""))
      				{
      					if ((ss = in.readLine()) == null )
          				{
          					break stop;
          				}
      				}
      			}
      	}catch (FileNotFoundException e) {
      		System.out.println("File not found: " + filename);
      	}catch (IOException e) 
      	{
      		System.out.println("IOException: the stack trace is:");
      		e.printStackTrace();
      	}
      	return inputs;
      }
     
}
