

#read the training chemical shift data, for the previous and next residues
data<-read.table('chemical_shifts_training_neighbor_two_combine_talos_shiftx.txt',sep=' ',)
data<-data[,-1]
colnames(data)<-c("ha","ca","cb","co","hn","n",
    "pre_ca","pre_cb","pre_co","pre_hn","pre_n",
    "next_ca", "next_cb","next_co","next_hn","next_n",
    "preTwo_ca","preTwo_cb","preTwo_co","preTwo_hn","preTwo_n",
    "nextTwo_ca", "nextTwo_cb","nextTwo_co","nextTwo_hn","nextTwo_n",
    "hbond_ha","hbond_hn","ring","ring_ca","cosPhi","cosPsi",
    "cosPhiPrev","cosPsiPrev","cosPhiNext","cosPsiNext","residue")

##process the data for three different cases:
#xFlag:TRUE or FALSE
data_process <- function(data,caFlag,cbFlag,coFlag,hnFlag,nFlag){
  data_temp<-matrix(NaN,length(data[,2]),37+6)
  data_temp[,1:37]<-data.matrix(data[,1:37])
 
  data_temp[,37+1]=as.numeric(data_temp[,1]>-100)*as.numeric(data_temp[,1]<100)
  if(caFlag)
  {
  	data_temp[,37+2]=as.numeric(data_temp[,2]>-100)*as.numeric(data_temp[,2]<100)
      data_temp[,37+2]=data_temp[,37+2]*as.numeric(data_temp[,7]>-100)*as.numeric(data_temp[,7]<100)
	data_temp[,37+2]=data_temp[,37+2]*as.numeric(data_temp[,12]>-100)*as.numeric(data_temp[,12]<100)
	data_temp[,37+2]=data_temp[,37+2]*as.numeric(data_temp[,17]>-100)*as.numeric(data_temp[,17]<100)
	data_temp[,37+2]=data_temp[,37+2]*as.numeric(data_temp[,22]>-100)*as.numeric(data_temp[,22]<100)  }  
  else  
	data_temp[,37+2]=as.numeric(TRUE)
 
  if(cbFlag){
  	data_temp[,37+3]=as.numeric(data_temp[,3]>-100)*as.numeric(data_temp[,3]<100)
	data_temp[,37+3]=data_temp[,37+3]*as.numeric(data_temp[,8]>-100)*as.numeric(data_temp[,8]<100)
	data_temp[,37+3]=data_temp[,37+3]*as.numeric(data_temp[,13]>-100)*as.numeric(data_temp[,13]<100)
	data_temp[,37+3]=data_temp[,37+3]*as.numeric(data_temp[,18]>-100)*as.numeric(data_temp[,18]<100)
	data_temp[,37+3]=data_temp[,37+3]*as.numeric(data_temp[,23]>-100)*as.numeric(data_temp[,23]<100)
	}
  else
	data_temp[,37+3]=as.numeric(TRUE)
 
  if(coFlag){
 	data_temp[,37+4]=as.numeric(data_temp[,4]>-100)*as.numeric(data_temp[,4]<100)
	data_temp[,37+4]=data_temp[,37+4]*as.numeric(data_temp[,9]>-100)*as.numeric(data_temp[,9]<100)
	data_temp[,37+4]=data_temp[,37+4]*as.numeric(data_temp[,14]>-100)*as.numeric(data_temp[,14]<100)
	data_temp[,37+4]=data_temp[,37+4]*as.numeric(data_temp[,19]>-100)*as.numeric(data_temp[,19]<100)
	data_temp[,37+4]=data_temp[,37+4]*as.numeric(data_temp[,24]>-100)*as.numeric(data_temp[,24]<100)
	}
  else  
	data_temp[,37+4]=as.numeric(TRUE)
  
  if(hnFlag){
	data_temp[,37+5]=as.numeric(data_temp[,5]>-100)*as.numeric(data_temp[,5]<100)
	data_temp[,37+5]=data_temp[,37+5]*as.numeric(data_temp[,10]>-100)*as.numeric(data_temp[,10]<100)
	data_temp[,37+5]=data_temp[,37+5]*as.numeric(data_temp[,15]>-100)*as.numeric(data_temp[,15]<100)
      data_temp[,37+5]=data_temp[,37+5]*as.numeric(data_temp[,20]>-100)*as.numeric(data_temp[,20]<100)
	data_temp[,37+5]=data_temp[,37+5]*as.numeric(data_temp[,25]>-100)*as.numeric(data_temp[,25]<100)}
  else  
	data_temp[,37+5]=as.numeric(TRUE)

  if(nFlag){
 	data_temp[,37+6]=as.numeric(data_temp[,6]>-100)*as.numeric(data_temp[,6]<100)
	data_temp[,37+6]=data_temp[,37+6]*as.numeric(data_temp[,11]>-100)*as.numeric(data_temp[,11]<100)
	data_temp[,37+6]=data_temp[,37+6]*as.numeric(data_temp[,16]>-100)*as.numeric(data_temp[,16]<100)
	data_temp[,37+6]=data_temp[,37+6]*as.numeric(data_temp[,21]>-100)*as.numeric(data_temp[,21]<100)
	data_temp[,37+6]=data_temp[,37+6]*as.numeric(data_temp[,26]>-100)*as.numeric(data_temp[,26]<100)
}
  else  
      data_temp[,37+6]=as.numeric(TRUE)

  data_temp[,37+6]=data_temp[,37+1]*data_temp[,37+2]*data_temp[,37+3]*data_temp[,37+4]*data_temp[,37+5]*data_temp[,37+6]

  clean_data<-data_temp[data_temp[,37+6]!= 0,]
  return (clean_data )
}


##################################
#2. parameter estimation 
clean_data<-data_process (data,TRUE,TRUE,FALSE,TRUE,TRUE)
data=clean_data

ha<-data[,1]
ca<-data[,2]
cb<-data[,3]
co<-data[,4]
hn<-data[,5]
n<-data[,6]

pre_ca<-data[,7]
pre_cb<-data[,8]
pre_co<-data[,9]
pre_hn<-data[,10]
pre_n<-data[,11]

next_ca<-data[,12]
next_cb<-data[,13]
next_co<-data[,14]
next_hn<-data[,15]
next_n<-data[,16]

preTwo_ca<-data[,17]
preTwo_cb<-data[,18]
preTwo_co<-data[,19]
preTwo_hn<-data[,20]
preTwo_n<-data[,21]

nextTwo_ca<-data[,22]
nextTwo_cb<-data[,23]
nextTwo_co<-data[,24]
nextTwo_hn<-data[,25]
nextTwo_n<-data[,26]


hbond_ha<-data[,27]
hbond_hn<-data[,28]
ring<-data[,29]
ring_ca<-data[,30]
cosPhi<-data[,31]
cosPsi<-data[,32]
cosPhiPrev<-data[,33]
cosPsiPrev<-data[,34]
cosPhiNext<-data[,35]
cosPsiNext<-data[,36]

library(gam)

dg=16 # degrees of freedom

fit_ha <- gam(ha~s(ca,dg)+s(cb,dg)+s(hn,dg)+s(n,dg)+s(pre_ca,dg)+s(pre_cb,dg)+s(pre_hn,dg)+s(pre_n,dg)
    +s(next_ca,dg)+s(next_cb,dg)+s(next_hn,dg)+s(next_n,dg)
    +s(preTwo_ca,dg)+s(preTwo_cb,dg)+s(preTwo_hn,dg)+s(preTwo_n,dg)
    +s(nextTwo_ca,dg)+s(nextTwo_cb,dg)+s(nextTwo_hn,dg)+s(nextTwo_n,dg)
    +s(hbond_ha,dg)+s(hbond_hn,dg)+s(ring,dg)+s(ring_ca,dg)
    +s(cosPhi,dg)+s(cosPsi,dg)+s(cosPhiPrev,dg)+s(cosPsiPrev,dg)
    +s(cosPhiNext,dg)+s(cosPsiNext,dg),family=gaussian())


summary(fit_ha) # display results

beta=fit_ha$coefficients  # vector of coefficients

sigma_5=sqrt( sum((ha-fit_ha$fitted.value)^2/length(ha)))
sigma_5
corr=cor(ha,fit_ha$fitted.value)
corr
#R2=corr^2
plot(ha,fit_ha$fitted.value, xlim=c(-4,2), ylim=c(-4,2))


######################
# 3 delete outliers, 
#whcih are 3 standard deviations from the mean

##3 iterations:
for(i in 1:3) { 

ha_pred=fit_ha$fitted.value
ring_temp=data[,29]
ca_ring_temp=data[,30]
data_temp<-matrix(NaN,length(ha_pred),6+36)
data_temp[,1:36]<-data.matrix(data[,1:36])

data_temp[,1+36]=ring_temp
data_temp[,2+36]=ha
#data_temp[,3+36]= ha_pred
data_temp[,3+36]= as.numeric( (abs(ca_ring_temp* beta[25])<1.5)  )
data_temp[,4+36]=as.numeric(abs(ha-ha_pred)< 3*sigma_5)
data_temp[,5+36]=as.numeric( (abs(ring_temp* beta[24])<1.5)  )
data_temp[,6+36]=data_temp[,4+36]*data_temp[,5+36]*data_temp[,3+36]

clean_data<-data_temp[data_temp[,6+36]!= 0,]
data=clean_data[,1:36]
 

ha<-data[,1]
ca<-data[,2]
cb<-data[,3]
co<-data[,4]
hn<-data[,5]
n<-data[,6]

pre_ca<-data[,7]
pre_cb<-data[,8]
pre_co<-data[,9]
pre_hn<-data[,10]
pre_n<-data[,11]

next_ca<-data[,12]
next_cb<-data[,13]
next_co<-data[,14]
next_hn<-data[,15]
next_n<-data[,16]

preTwo_ca<-data[,17]
preTwo_cb<-data[,18]
preTwo_co<-data[,19]
preTwo_hn<-data[,20]
preTwo_n<-data[,21]

nextTwo_ca<-data[,22]
nextTwo_cb<-data[,23]
nextTwo_co<-data[,24]
nextTwo_hn<-data[,25]
nextTwo_n<-data[,26]

hbond_ha<-data[,27]
hbond_hn<-data[,28]
ring<-data[,29]
ring_ca<-data[,30]
cosPhi<-data[,31]
cosPsi<-data[,32]
cosPhiPrev<-data[,33]
cosPsiPrev<-data[,34]
cosPhiNext<-data[,35]
cosPsiNext<-data[,36]

fit_ha <- gam(ha~s(ca,dg)+s(cb,dg)+s(hn,dg)+s(n,dg)+s(pre_ca,dg)+s(pre_cb,dg)+s(pre_hn,dg)+s(pre_n,dg)
    +s(next_ca,dg)+s(next_cb,dg)+s(next_hn,dg)+s(next_n,dg)
    +s(preTwo_ca,dg)+s(preTwo_cb,dg)+s(preTwo_hn,dg)+s(preTwo_n,dg)
    +s(nextTwo_ca,dg)+s(nextTwo_cb,dg)+s(nextTwo_hn,dg)+s(nextTwo_n,dg)
    +s(hbond_ha,dg)+s(hbond_hn,dg)+s(ring,dg)+s(ring_ca,dg)
    +s(cosPhi,dg)+s(cosPsi,dg)+s(cosPhiPrev,dg)+s(cosPsiPrev,dg)
    +s(cosPhiNext,dg)+s(cosPsiNext,dg),family=gaussian())


summary(fit_ha) # display results
beta=fit_ha$coefficients  # vector of coefficients
sigma_5=sqrt( sum((ha-fit_ha$fitted.value)^2/length(ha)))
sigma_5
corr=cor(ha,fit_ha$fitted.value)
corr
#R2=corr^2
plot(ha,fit_ha$fitted.value)

}
summary(fit_ha)
sigma_5
corr
plot(ha,fit_ha$fitted.value,pch=20,cex = 0.8,xlim=c(-2,2),ylim=c(-2,2),xlab="Experimental shifts",ylab="Predicted shifts")

#plot(ha,n,pch=20,cex = 0.8)



##################################
#4. Read the testing data
data_test<-read.table('r_test_data_two_neighbors.txt',sep=' ',)
data_test<-data_test[,-1]
colnames(data_test)<-c("ha","ca","cb","co","hn","n",
    "pre_ca","pre_cb","pre_co","pre_hn","pre_n",
    "next_ca", "next_cb","next_co","next_hn","next_n",
    "preTwo_ca","preTwo_cb","preTwo_co","preTwo_hn","preTwo_n",
    "nextTwo_ca", "nextTwo_cb","nextTwo_co","nextTwo_hn","nextTwo_n",  
    "hbond_ha","hbond_hn","ring","ring_ca","cosPhi","cosPsi",
    "cosPhiPrev","cosPsiPrev","cosPhiNext","cosPsiNext","residue","no","protein")

ha_test<-data_test[,1]

##remove outliers with large ring effect:
ring_temp=data_test[,29]
ca_ring_temp=data_test[,30]

data_temp<-data_test[,1:39]
data_temp<-cbind(data_temp, as.numeric( (abs(ca_ring_temp* beta[25])<1.5)))
data_temp<-cbind(data_temp,as.numeric( (abs(ring_temp* beta[24])<1.5))  )
data_temp<-cbind(data_temp, data_temp[,40]*data_temp[,41])

clean_data<-data_temp[data_temp[,42]!= 0,]
data_test=clean_data[,1:39]

ha_test<-data_test[,1]
out<-predict.gam(fit_ha, newdata=data_test, se.fit = TRUE)



sigma=sqrt(mean((ha_test-out)^2))
sigma
corr=cor(ha_test,out)
corr
#R2=corr^2
plot(ha_test,out)

data_temp<-cbind(data_test,out)
output_data<-cbind(array(data_temp$protein),data_temp$no,data_temp$out)
filename="r_predicted_ha.txt"

#filename=paste(filename, '.txt', sep='')

write(t(output_data),ncolumns =3, filename )



